import { UserLevel } from "../enums/UserLevel";

export default class User {
	public Id:number;
	public UserLevel:UserLevel;
	public get UserLevelString() {
		return UserLevel[this.UserLevel];
	}
	public Username:string;
	public PasswordSalt:string;
	public PasswordHash:string;
	public APIKey:string;
	public CreatedByUserId:number;
	public CreatedDatetime:Date;
	public LastModifiedByUserId?:number;
	public LastModifiedDatetime?:Date;
	public DeletedByUserId?:number;
	public DeletedDatetime?:Date;
	public IsDeleted:boolean;

	public constructor(id?:number, userLevel?:UserLevel, username?:string, passwordSalt?:string, passwordHash?:string, apiKey?:string, createdByUserId?:number, createdDateTime?:Date, lastModifiedByUserId?:number, lastModifiedDatetime?:Date, deletedByUserId?:number, deletedDatetime?:Date, isDeleted?:boolean) {
		if (typeof(id) == "number" && typeof(userLevel) == "number" && typeof(username) == "string" && typeof(passwordHash) == "string" && typeof(passwordSalt) == "string" && typeof(apiKey) == "string" && typeof(createdByUserId) == "number" && createdDateTime instanceof Date && typeof(lastModifiedByUserId) == "number" && lastModifiedDatetime instanceof Date && typeof(deletedByUserId) == "number" && deletedDatetime instanceof Date && typeof(isDeleted) == "boolean") {
			this.Id = id;
			this.UserLevel = userLevel;
			this.Username = username;
			this.PasswordHash = passwordHash;
			this.PasswordSalt = passwordSalt;
			this.APIKey = apiKey;
			this.CreatedByUserId = createdByUserId;
			this.CreatedDatetime = createdDateTime;
			this.LastModifiedByUserId = lastModifiedByUserId;
			this.LastModifiedDatetime = lastModifiedDatetime;
			this.DeletedByUserId = deletedByUserId;
			this.DeletedDatetime = deletedDatetime;
			this.IsDeleted = isDeleted;
		} else {
			this.Id = Number.MIN_VALUE;
			this.UserLevel = UserLevel.Unknown;
			this.Username = "";
			this.PasswordHash = "";
			this.PasswordSalt = "";
			this.APIKey = "";
			this.CreatedByUserId = Number.MIN_VALUE;
			this.CreatedDatetime = new Date(0);
			this.IsDeleted = false;
		}
	}
}